#include <stdio.h>
#include <stdlib.h>

int o(int d)
{
    if(d==1)
    {
        return 1;
    }
    if(d==2)
    {
        return 3;
    }
    int s=1;
    for(int i=2;i<=d/3;i++)
    {
        if(d%i==0)
        {
            s^=i;
        }
    }
    if(d%2==0)
    {
        s^=d/2;
    }
    s^=d;
    return s;
}

int main()
{
    int n,k;
    scanf("%d",&n);
    scanf("%d",&k);
    int d[k];
    for(int i=0;i<k;i++)
    {
        scanf("%d",&d[i]);
    }
    for(int i=0;i<k;i++)
    {
        printf("%d ",o(d[i]));
    }
    return 0;
}